<template>
  <Spinner v-if="isLoading"/>

  <div v-else-if="results" class="row mb-2">
    <h1>This is the Marvel movie list</h1>

    <div class="col-9 mb-4">
      <input type="text" v-model="searchQuery" class="form-control col-3" placeholder="Filter movie displayed.."/>
    </div>

    <div class="col-3 displayed-results text-end">
      <strong>Total Displayed:</strong> <u>{{ displayedResults }}</u>
    </div> 

    <div v-for="movie in filteredList" :key="movie.imdbID" class="col-md-6">
      <Movie :movie="movie"/>
    </div>
  </div>

  <div v-else>{{ error }}</div>
</template>

<script>
import { computed } from 'vue';
import useFetch from '../composable/use-fetch';
import useSearch from '../composable/use-search';

import Spinner from '@/components/Spinner.vue';
import Movie from '@/components/Movie.vue';

export default {
  components: {
    Spinner,
    Movie
  },
  setup() {
    console.log('this', this);
    const { results, isLoading, error } = useFetch('http://www.omdbapi.com/?apikey=522175a0&s=marvel&type=movie&page=1');
    
    // filter logic
    const { searchQuery, filteredList } = useSearch(results, 'Title');

    // computed data
    const displayedResults = computed(() => filteredList.value.length);

    return { results, isLoading, error, filteredList, searchQuery, displayedResults };
  }
}
</script>
